=== debian/changelog ===
volk (2.2.1-1) unstable; urgency=high

  * New upstream bugfix release
    reason for high urgency:
    - Fix loop bound in AVX rotator (only one fixed in 2.2.0-3)
    - Fix out-of-bounds read in AVX2 square dist kernel
    - Fix length checks in AVX2 index max kernels

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 24 Feb 2020 18:08:05 -0500

volk (2.2.0-3) unstable; urgency=high

  * Update to v2.2.0-6-g5701f8f
    reason for high urgency:
    - Fix loop bound in AVX rotator

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 23 Feb 2020 23:49:18 -0500

volk (2.2.0-2) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 18 Feb 2020 17:56:58 -0500

volk (2.2.0-1) experimental; urgency=medium

  * New upstream release
    - Remove build dependency on python six
    - Fixup VolkConfigVersion
    - add volk_version.h

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 16 Feb 2020 18:25:20 -0500
