=== debian/watch ===
version=4
 opts="pgpsigurlmangle=s%$%.asc%,filenamemangle=s%(?:.*?)?volk-?(\d[\d.]*)\.tar\.xz%volk_$1.orig.tar.xz%" \
 https://github.com/gnuradio/volk/releases \
 (?:.*?/)?volk-?(\d[\d.]*)\.tar\.xz debian uupdate
