=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -154,17 +154,8 @@
         RESULT_VARIABLE avx_compile_result)
     if(NOT ${avx_compile_result} EQUAL 0)
         OVERRULE_ARCH(avx "Compiler or linker missing xgetbv instruction")
-    elseif(NOT CROSSCOMPILE_MULTILIB)
-        execute_process(COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv
-            OUTPUT_QUIET ERROR_QUIET
-            RESULT_VARIABLE avx_exe_result)
-        if(NOT ${avx_exe_result} EQUAL 0)
-            OVERRULE_ARCH(avx "CPU missing xgetbv")
-        else()
-            set(HAVE_XGETBV 1)
-        endif()
     else()
-        # cross compiling and compiler/linker seems to work; assume working
+        # compiler/linker seems to work; assume working
         set(HAVE_XGETBV 1)
     endif()
     file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/test_xgetbv
@@ -184,15 +175,6 @@
           RESULT_VARIABLE avx_compile_result)
         if(NOT ${avx_compile_result} EQUAL 0)
           OVERRULE_ARCH(avx "Compiler missing cvtpi32_ps instrinsic")
-        elseif(NOT CROSSCOMPILE_MULTILIB)
-          execute_process(COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_cvtpi32_ps
-            OUTPUT_QUIET ERROR_QUIET
-            RESULT_VARIABLE avx_exe_result)
-          if(NOT ${avx_exe_result} EQUAL 0)
-            OVERRULE_ARCH(avx "CPU missing cvtpi32_ps")
-          else()
-            set(HAVE_AVX_CVTPI32_PS 1)
-          endif()
         else()
           set(HAVE_AVX_CVTPI32_PS 1)
         endif()
@@ -275,3 +257,23 @@
 ########################################################################
 # implement overruling in the ORC case,
 # since ORC always passes flag detection
+########################################################################
+if(NOT ORC_FOUND)
+    OVERRULE_ARCH(orc "ORC support not found")
+endif()
+
+########################################################################
+# implement overruling in the non-multilib case
+# this makes things work when both -m32 and -m64 pass
+########################################################################
+if(NOT CROSSCOMPILE_MULTILIB AND CPU_IS_x86)
+    include(CheckTypeSize)
+    check_type_size("void*[8]" SIZEOF_CPU BUILTIN_TYPES_ONLY)
+    if (${SIZEOF_CPU} EQUAL 64)
+        OVERRULE_ARCH(32 "CPU width is 64 bits")
+    endif()
+    if (${SIZEOF_CPU} EQUAL 32)
+        OVERRULE_ARCH(64 "CPU width is 32 bits")
+    endif()
+
+    #MSVC 64 bit does not have MMX, overrule it
