=== debian/changelog ===
volk (2.3.0-3) unstable; urgency=medium

  * update to v2.3.0-14-g91e5d07
    emit an emms instruction after using the mmx extension

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 30 Jun 2020 19:48:20 -0400

volk (2.3.0-2) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 11 May 2020 07:26:03 -0400

volk (2.3.0-1) experimental; urgency=medium

  * New upstream release, to experimental for soversion bump
  * Kernels
    - volk: accurate exp kernel
        - exp: Rename SSE4.1 to SSE2 kernel
    - Add 32f_s32f_add_32f kernel
        - This kernel adds in vector + scalar functionality
    - Fix the broken index max kernels
    - Treat the mod_range puppet as such
    - Add puppet for power spectral density kernel
    - Updated log10 calcs to use faster log2 approach
    - fix: Use unaligned load
    - divide: Optimize complexmultiplyconjugate

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 09 May 2020 15:42:23 -0400

volk (2.2.1-3) unstable; urgency=medium

  * update to v2.2.1-34-gd4756c5

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 05 Apr 2020 10:37:46 -0400

volk (2.2.1-2) unstable; urgency=medium

  * update to v2.2.1-11-gfaf230e
  * cmake: Remove the ORC from the VOLK public link interface
  * Fix the broken index max kernels

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 27 Mar 2020 21:48:10 -0400
